#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>

static unsigned char ch_db_buf, jis_sgi[3], jis_flg, euc_hankaku = 0x8e;
int hankaku_flg;
extern char log_flg;
extern int ch_db_flg, logfd, connect_flg;
void Auto_save();

char *Sjis2euc( ch_in, ch_in2 )  /* change S-JIS to EUC */
unsigned char ch_in, ch_in2;
{
  int even_flg;
  static unsigned char ch_db[2];

  ch_db[0] = ch_in;
  ch_db[1] = ch_in2;

  if ( 64 <= ch_db[1] && ch_db[1] <= 126 )
  {
    ch_db[1] += 97;
    even_flg = 0;
  }
  else if ( 128 <= ch_db[1] && ch_db[1] <= 158 )
  {
    ch_db[1] += 96;
    even_flg = 0;
  }
  else if ( 158 < ch_db[1] )
  {
    ch_db[1] += 2;
    even_flg = 1;
  }

  if ( 129 <= ch_db[0] && ch_db[0] <= 159 )
  {
    ch_db[0] = ch_db[0] * 2 - 97;
    if ( even_flg )
      ch_db[0] += 1;
  }
  else if ( 224 <= ch_db[0] && ch_db[0] <= 239 )
  {
    ch_db[0] = ch_db[0] * 2 - 225;
    if ( even_flg )
      ch_db[0] += 1;
  }
  return(ch_db);
}

char *Euc2sjis( ch_in, ch_in2 )  /* change EUC to S-JIS */
unsigned char ch_in, ch_in2;
{
  static unsigned char ch_db[2];
  unsigned char odd;

  ch_db[0] = ch_in;
  ch_db[1] = ch_in2;

  odd = ch_in & 0x01;

  if ( 161 <= ch_db[0] && ch_db[0] <= 222 )
    ch_db[0] = ( ch_db[0] - 161 ) / 2 + 129; 
  else if ( 223 <= ch_db[0] && ch_db[0] <= 254 )
    ch_db[0] = ( ch_db[0] - 161 ) / 2 + 193;

  if ( odd != 0 )
  {
    if ( 161 <= ch_db[1] && ch_db[1] <= 223 )
      ch_db[1] -= 97;
    else if ( 224 <= ch_db[1] && ch_db[1] <= 254 )
      ch_db[1] -= 96;
  }
  else
    ch_db[1] -= 2;

  return(ch_db);
}

void Write_data( ch_in, len )
unsigned char *ch_in;
int len;
{
    write(1, ch_in, len);
    if( log_flg == 1 )
      if( (write( logfd, ch_in, len )) == -1 )
	printf("write err\n");
}

void Res_JIS_code( ch_in )  /*  receive JIS code  */
unsigned char ch_in;
{
  if( ch_in == 0x1b || jis_flg == 1 || jis_flg == 2 )
  {
    if( ch_in == 0x1b )
      jis_flg = 0;
    jis_sgi[jis_flg] = ch_in;
    jis_flg += 1;
    return;
  }

  if( jis_flg >= 3 )
  {
    if( jis_sgi[1] == 0x24 && jis_sgi[2] == 0x42 )
    {
      ch_db_flg = 1;
      hankaku_flg = 0;
    }
    if( jis_sgi[1] == 0x28 && jis_sgi[2] == 0x49 )
    {
      ch_db_flg = 0;
      hankaku_flg = 1;
    }
    if( (jis_sgi[1] == 0x28 && jis_sgi[2] == 0x42) ||
	(jis_sgi[1] == 0x28 && jis_sgi[2] == 0x4a) )
    {
      ch_db_flg = 0;
      hankaku_flg = 0;
    }
    jis_flg = 0;
  }

  if( ch_db_flg == 0 && hankaku_flg == 0 )
  {
    if( ch_in & 0x80 )
      Write_data( &euc_hankaku, 1 );
    Write_data( &ch_in, 1 );
  }
  else if( ch_db_flg == 1 && hankaku_flg == 0 )
  {
    if( ch_in == 0x0d || ch_in == 0x0a )
      ch_db_buf = ch_in;
    else
      ch_db_buf = ch_in | 0x80;

    Write_data( &ch_db_buf, 1 );
  }
  else if( ch_db_flg == 0 && hankaku_flg == 1 )
  {
    if( ch_in == 0x0d || ch_in == 0x0a )
      ch_db_buf = ch_in;
    else
    {
      ch_db_buf = ch_in | 0x80;
      Write_data( &euc_hankaku, 1 );
    }
    Write_data( &ch_db_buf, 1 );
  }
}

void Res_EUC_code( ch_in )  /*  receive EUC code  */
unsigned char ch_in;
{
  Write_data( &ch_in, 1 );
}

void Res_SJIS_code( ch_in )  /*  receive SJIS code  */
unsigned char ch_in;
{
  unsigned char *ch_db;

  if( ch_db_flg == 0 )
  {
    if( ch_in & 0x80 )
    {
      if( (129 <= ch_in && ch_in <= 159) ||
          ( 224 <= ch_in && ch_in <= 239) )
      {
        ch_db_buf = ch_in;
	ch_db_flg = 1;
        return;
      }
      else if( 160 <= ch_in && ch_in <= 223 )
      {
	Write_data( &euc_hankaku, 1 );
	Write_data( &ch_in, 1 );
      }
    }
    else
    {
      Write_data( &ch_in, 1 );
    }
  }
  else
  {
    ch_db = Sjis2euc( ch_db_buf, ch_in );  /* change S-JIS to EUC */
    Write_data( ch_db, 2 );
    ch_db_flg = 0;
  }
}
