#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dirent.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <sys/types.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/AsciiText.h>

Widget  popup, dirview, fileview, filelist;
char **listfile;
int dir_cnt;
void Euc2sjis(), Send_text();
extern int pipe_tl1[1];

void Clear_list()
{
  int i;

  for( i = 0; i < dir_cnt ; i++ )
    XtFree( listfile[i] );
  XtFree((char *)listfile );
}

int comp( x, y )
char **x;
char **y;
{
  return( strcmp( *x, *y ));
}

void Set_string_text( w, name )
Widget  w;
char *name;
{
  Arg arg[1];

  XtSetArg( arg[0], XtNstring, name );
  XtSetValues( w, arg, 1 );
}

void Inputlist() /* set filename to buffer */
{
  DIR  *dir;
  char dir_buf[256], *dn;
  struct dirent *dirfile;
  struct stat sbuf;
  int cnt;

  cnt = 0;

  dir = opendir(".");
  while((dirfile = readdir(dir)) != NULL)
    cnt ++;
  closedir(dir);

  listfile = (char **) XtMalloc( sizeof( char * ) * cnt );
  cnt = 0;
  dir = opendir(".");
  while((dirfile = readdir(dir)) != NULL)
  {
    dn = dirfile->d_name;
    if( dn[0] == '.' )
    {
      if( dn[1] == '\0' )
	continue;
      if( dn[1] == '.' && dn[2] == '\0' )
      {
	listfile[cnt] =  XtNewString("../");
	cnt ++;
	continue;
      }
    }
    stat( dn, &sbuf );
    if ( S_ISDIR( sbuf.st_mode) )
    {
      listfile[cnt] = XtMalloc(sizeof(char) * strlen(dn) + 2);
      strcpy(listfile[cnt], dn);
      strcat(listfile[cnt], "/");
      cnt ++;;
    }
    else
    {
      listfile[cnt] = XtNewString(dirfile->d_name);
      cnt ++;
    }
  }

  getcwd( dir_buf, sizeof( dir_buf ));
  Set_string_text( dirview, dir_buf );

  closedir(dir);
  dir_cnt = cnt;
  qsort( listfile, dir_cnt, sizeof( char * ), comp);

  XawListChange( filelist, listfile, dir_cnt, 0, True );

  return;
}

void Select( w, client_data, call_data ) /* select file */
Widget  w;
caddr_t client_data;
caddr_t call_data;
{
  char *f_name;
  struct stat sbuf;
  XawListReturnStruct  *f_ret;

  f_ret = (XawListReturnStruct *)call_data;

  f_name = f_ret->string;
  Set_string_text( fileview, f_name );

  stat( f_name, &sbuf );
  if ( S_ISDIR( sbuf.st_mode) )
  {
    chdir( f_name );
    Clear_list();
    Inputlist();
  }

}

void Send_jisfile( textfd )
int textfd;
{
  unsigned char t_data, t_data2;

  while( read( textfd, &t_data, 1) )
  {
    if( t_data == 27 )
    {
      read( textfd, &t_data, 1 );
      if( t_data == 40 )
      {
	read( textfd, &t_data, 1 );
	if( t_data == 66 )
	  break;        /*  end kanji mode */
      }
    }
    else
    {
      read( textfd, &t_data2, 1 );
      t_data |= 0x80;
      t_data2 |= 0x80;               /* change JIS to EUC  */
      Euc2sjis( t_data, t_data2 );  /* change EUC to S-JIS */
    }
  }
}


void Upload( w, client_data, call_data )
Widget  w;
caddr_t client_data;
caddr_t call_data;
{
  String fname;
  Widget tw;
  int textfd, i;
  unsigned char t_data, chk_crlf, chk_jis, chk_hankaku, *td_buf;
  unsigned char jis_sgi[2], euc_hankaku = 0x8e;
  static unsigned char *td;

  tw = (Widget)client_data;
  i = 0;
  chk_jis = 0;

  XtVaGetValues( tw, XtNstring, &fname, NULL );

  if((textfd = open( fname, O_RDONLY, S_IRUSR | S_IRUSR )) == -1)
    printf("cannnot open %s\n",fname);
  else
  {
    while( read(textfd, &t_data, 1) )
    {
      if( t_data != 0x0a && t_data != 0x0d )
      {
	if( t_data == 0x1b )
	{
	  read( textfd, &jis_sgi[0], 1);
	  read( textfd, &jis_sgi[1], 1);
	  if( jis_sgi[0] == 0x24 && jis_sgi[1] == 0x42 )
	    /*  textcode is JIS  */
	  {
	    chk_jis = 1;
	    chk_hankaku = 0;
	  }
	  else if( jis_sgi[0] == 0x28 && jis_sgi[1] == 0x49 )
	    /*  textcode is hankaku-katakana  */
	  {
	    chk_jis = 0;
	    chk_hankaku = 1;
	  }
	  else if( (jis_sgi[0] == 0x28 && jis_sgi[1] == 0x42) ||
		   (jis_sgi[0] == 0x28 && jis_sgi[1] == 0x4a) )
	    /*  textcode is ASCII  */
	  {
	    chk_jis = 0;
	    chk_hankaku = 0;
	  }
	  continue;
	}
	else
	{
	  if ( chk_jis == 1 || chk_hankaku == 1 )
	    t_data |= 0x80;
	  if ( chk_hankaku == 1 )
	  {
	    td_buf = td;
	    td = (char*)malloc((i+2)*sizeof(char));
	    memcpy(td, td_buf, i);
	    memcpy(td+i, &euc_hankaku, 1);
	    free( td_buf );
	    i += 1;
	  }
	  td_buf = td;
	  td = (char*)malloc((i+2)*sizeof(char));
	  memcpy(td, td_buf, i);
	  memcpy(td+i, &t_data, 1);
	  free( td_buf );
	  i += 1;
	}
      }
      else
      {
	if( t_data == 0x0a && chk_crlf == 0x0d )
	  continue;
	Send_text( td, i );
	i = 0;
	chk_crlf = t_data;
      }
    }
    close( textfd );
  }
}

void Popdown()
{
  XtPopdown( popup );
}

void Open_file_popup(w)  /* popup text list */
Widget w;
{
  Inputlist();
  XtPopup( popup, XtGrabExclusive );
}

void Delete_filepop( w, event, params, num_params )  /*  Delete file popup  */
Widget w;
XEvent *event;
String *params;
int    num_params;
{
  Popdown();
}

void Textpopup(parent)
Widget parent;
{
  Widget  box, paned, vport, done, close;
  static XtActionsRec actions[] = {{"delete", Delete_filepop}};
  static Atom wm_delete_window;

  popup  = XtCreatePopupShell("popup", topLevelShellWidgetClass, parent,
			      NULL, 0);
  box    = XtCreateManagedWidget("box", boxWidgetClass, popup,
				    NULL, 0);
  dirview  = XtVaCreateManagedWidget("dirview", asciiTextWidgetClass, box,
				     XtNlength, 128,
				     XtNwidth, 300,
				     NULL);
  fileview  = XtVaCreateManagedWidget("fileview", asciiTextWidgetClass, box,
				     XtNlength, 128,
				     XtNwidth, 300,
				     NULL);
  paned = XtVaCreateManagedWidget("paned", panedWidgetClass, box, 
				   XtNborderWidth, 1,
				   XtNwidth, 300,
				   XtNheight, 400, 
				   NULL);

  vport  = XtVaCreateManagedWidget("vport", viewportWidgetClass, paned,
				   XtNallowVert, TRUE,
				   XtNuseBottom, True,
				   XtNuseRight, True,
				   NULL);
  filelist   = XtVaCreateManagedWidget("fileList", listWidgetClass, vport,
				       XtNforceColumns, True,
				       XtNdefaultColumns, 1,
				       NULL);
  done  = XtCreateManagedWidget("done", commandWidgetClass, box,
				   NULL, 0);
  close  = XtCreateManagedWidget("close", commandWidgetClass, box,
				   NULL, 0);

  XtAddCallback(filelist, XtNcallback, Select, fileview);
  XtAddCallback(done, XtNcallback, Upload, fileview);
  XtAddCallback(close, XtNcallback, Popdown, NULL);

  XtAddActions( actions, XtNumber(actions) );
  XtOverrideTranslations( popup,
	    XtParseTranslationTable("<Message>WM_PROTOCOLS: delete()"));
  wm_delete_window = XInternAtom(XtDisplay(popup), "WM_DELETE_WINDOW", False);

  XtRealizeWidget( popup );

  XSetWMProtocols( XtDisplay(popup), XtWindow(popup), &wm_delete_window, 1 );
}

