#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <termios.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <sys/types.h>

struct conect{
  char name[10];
  char host[30];
  int s_log;
  char incode;
  char outcode;
}list[5];

char *execname;
int list_no;

extern int default_kanji_code;

int Inst_flg( command, flg )
char *command;
char *flg;
{
  if( strcmp(command, "TELNET") == 0 )
  {
    execname = (char*)malloc((strlen(flg)+1)*sizeof(char));
    strcpy(execname,flg);
  }
  else if( strcmp(command, "KANJI_CODE") == 0 )
  {
    default_kanji_code = atoi(flg);
  }
  else if( strcmp(command, "HOSTNAME") == 0 )
  {
    strcpy(list[list_no].name,flg);
  }
  else if( strcmp(command, "HOST") == 0 )
  {
    strcpy(list[list_no].host,flg);
  }
  else if( strcmp(command, "SAVELOG") == 0 )
  {
    if( strcmp(flg, "ON") == 0  )
      list[list_no].s_log = 1;
    else
      list[list_no].s_log = 0;
    list_no ++;
  }
  return(1);
}

void Read_ini_file()
{
  FILE  *fp;
  int   i, j;
  char  buf[256],
        cbuf[16],
        fbuf[16],
        *pathdir,
        *pathname,
        *command,
        *flg;

  list_no = 0;
  pathdir = getenv("HOME");
  pathname = (char*)malloc((strlen(pathdir)+9)*sizeof(char));
  strcpy(pathname,pathdir);
  strcat(pathname,"/tlinit");

  if((fp = fopen( pathname, "r" )) == NULL )
  {
    return;
  }

  while( fgets( buf, 255, fp ) != NULL )
  {
    if( buf[0] == '#' || buf[0] == '\0' )
      continue;

    memset( cbuf, 0, sizeof(cbuf) );
    for( i = 0; buf[i] != 0x20; i++ )
      cbuf[i] = buf[i];
    cbuf[i+1] = '\0';

    command = (char*)malloc((strlen(cbuf)+1)*sizeof(char));
    strcpy(command, cbuf);

    memset( fbuf, 0, sizeof(fbuf) );
    j = 0;
    for( ; buf[i] != 0x0a; i++ )
    {
      if( buf[i] == '#' )
	break;
      else if( buf[i] == 0x20 )
	continue;
      fbuf[j] = buf[i];
      j ++;
    }

    fbuf[j] = '\0';
    flg = (char*)malloc((strlen(fbuf)+1)*sizeof(char));
    strcpy(flg, fbuf);

    if( Inst_flg( command, flg ) == 0 )
      exit(0);

    free( command );
    free( flg );
  }

  free( pathname );
  fclose( fp );

}
